﻿var canvas;
var context;
var circles = [];	// Переменная хранящая объеты нарисованных мышкой точек
var maxelX;			// максимальный элемент по оси Х
var minelX;			// минимальный элемент по оси Х
var maxelY;			// максимальный элемент по оси Y
var minelY;			// минимальный элемент по оси Y
var scaleX = 0;		// Переменная Маштаба по x
var positionX = 0;	// Переменная позиции по x
var scaleY = 0;		// Переменная Маштаба по y
var positionY = 0;	// Переменная позиции по y
var x = 10;			// начало коорлинат х
var y = 1090;		// начало координат y

// Начало блока установки точек и возможности их перетаскивать
window.onload = function() {					//Функция срабатывающая при загрузке страницы. 
      canvas = document.getElementById("cnvs");	// Подключает canvas
      context = canvas.getContext("2d");		// очищает холст
      canvas.onmousedown = canvasClick;			// на событие: "нажатие кнопки мыши", устанавливаем функцию, в которой прописываются действия для этого события
      canvas.onmouseup = stopDragging;			// на событие: "отжатие кнопки мыши", устанавливаем функцию, в которой прописываются действия для этого события
      canvas.onmouseout = stopDragging;			// на событие: "выхода стрелки мыши за прееделы поля", устанавливаем функцию, в которой прописываются действия для этого события
      canvas.onmousemove = dragCircle;			// на событие: "движение нажатой левой кнопки мыши", устанавливаем функцию, в которой прописываются действия для этого события
   }
var abc = 0;						// Переменная отвечающая за счётчик нажатий на холст при рисовании двух точек, между которыми мы проводим линию
var previousSelectedCircle;			// Предыдущий выбранный круг. Отвечает за хранения информации о круге, нарисованный мышью, который был выбран ранее 
var isDragging = false;				// Переменная хранящяя информацию о том можно ли начать перетаскивать круг или нет
var previousSelectedCircleCanvas;	// Предыдущий выбранный круг. Отвечает за хранения информации о круге, нарисованном программой, который был выбран ранее

function canvasClick(e) {																											// Функция работающая на событие "нажатие кнопки мыши"
	var clickX = e.pageX - canvas.offsetLeft;																						// Координата мыши по Х (с учётом того, что нам её надо получить относительно холста а не окна)
	var clickY = e.pageY - canvas.offsetTop;																						// Координата мыши по Y (с учётом того, что нам её надо получить относительно холста а не окна)
	if (abc < 2) addCircle(clickX, clickY, 6, "000000");																			// Нажатием левой кнопки мыши рисуем круг на холсте, пока не нарисовали 2 круга, потом процесс останавливается
	abc++;																															// Увеличиваем счётчик
	for(var i=circles.length-1; i>=0; i--) {																						// Проверяем, щелкнули ли no кругу, перебераем все круги в массиве
		var circle = circles[i];																									// каждый новый цикл присваеваем создаем объект = объекту круга из массива
		var distanceFromCenter = Math.sqrt(Math.pow(circle.x - clickX, 2) + Math.pow(circle.y - clickY, 2)) 						// С помощью теоремы Пифагора вычисляем расстояние от точки, в которой щелкнули, до центра текущего круга
		if (distanceFromCenter <= circle.radius) {																					// Определяем, находится ли точка, в которой щелкнули, в данном круге	
		  if (previousSelectedCircle != null) previousSelectedCircle.isSelected = false;											// Сбрасываем предыдущий выбранный круг. Если он существует, то снимаем с него информацию о том что он выбран
		  previousSelectedCircle = circle;																							// и теперь предыдущий выбранный круг - это данный круг, который мы обрабатываем
		  circle.isSelected = true;																									// Устанавливаем новый круг в качестве выбранного
		  drawCircles();																											// Обновляем отображение всех рисунков на хосте
		  isDragging = true;																										// разрешаем перетаскивание, если мы щелкнули на круг.
		  return;																													// Прекращаем проверку, так как данный круг и является тем, на который щелкнули
		}
		else {																														// иначе, елси не был выбран ни один из кругов
			if (previousSelectedCircle != null) previousSelectedCircle.isSelected = false;											// Сбрасываем предыдущий выбранный круг. Если он существует, то снимаем с него информацию о том что он выбран
			drawCircles();																											// Обновляем отображение всех рисунков на хосте
		}
	}
	for(var i=circlesCanvas.length-1; i>=0; i--) {																					// Проверяем, щелкнули ли no кругу, перебераем все круги в массиве кругов холста
		var circle = circlesCanvas[i];																								// каждый новый цикл присваеваем создаем объект = объекту круга из массива
		var distanceFromCenter = Math.sqrt(Math.pow(x + circle.positionX - clickX, 2) + Math.pow(y - circle.positionY - clickY, 2)) // С помощью теоремы Пифагора вычисляем расстояние от точки, в которой щелкнули, до центра текущего круга
		if (distanceFromCenter <= circle.radius) {																					// Определяем, находится ли точка, в которой щелкнули, в данном круге	
		  if (previousSelectedCircleCanvas != null) previousSelectedCircleCanvas.isSelectedText = false;							// Сбрасываем предыдущий выбранный круг. Если он существует, то снимаем с него информацию о том что он выбран
		  previousSelectedCircleCanvas = circle;																					// и теперь предыдущий выбранный круг - это данный круг, который мы обрабатываем
		  circle.isSelectedText = true;																								// Устанавливаем новый круг в качестве выбранного
		  drawCircles();																											// Обновляем отображение всех рисунков на хосте
		  return;																													// Прекращаем проверку, так как данный круг и является тем, на который щелкнули
		}
		else {																														// иначе, елси не был выбран ни один из кругов
			if (previousSelectedCircleCanvas != null) previousSelectedCircleCanvas.isSelectedText = false;							// Сбрасываем предыдущий выбранный круг. Если он существует, то снимаем с него информацию о том что он выбран
			drawCircles();																											// Обновляем отображение всех рисунков на хосте
		}
	}
}

function stopDragging() {	// Функция работающая на событие "отжатие кнопки мыши" или "выхода стрелки мыши за прееделы поля"
  isDragging = false;		// Запретить перетаскивание круга
}

function dragCircle(e) {					//Функция работающая на событие "движение нажатой левой кнопки мыши"
  if (isDragging == true) {					// Проверка возможности перетаскивания 
    if (previousSelectedCircle != null) {	// Проверка попадания, т. е. если пердыдущий круг существует
      var x = e.pageX - canvas.offsetLeft;	// Сохраняем позицию мыши координата по Х
      var y = e.pageY - canvas.offsetTop;	// Сохраняем позицию мыши координата по Y
      previousSelectedCircle.x = x;			// Перемещаем круг в новую позицию координата по Х
      previousSelectedCircle.y = y;			// Перемещаем круг в новую позицию координата по Y
      drawCircles();						// Обновляем отображение всех рисунков на хосте, это происходить при смещении на каждый пиксель
    }
  }
}

function Circle(x, y, radius, color) {	// Функция рирования круга и переменной храняйщей в себе информацию о том, нажали мы на круг или нет
    this.x = x;							// Переменной x этой функции присваиваем значение x которое мы передали при её вызове
    this.y = y;							// Переменной y этой функции присваиваем значение y которое мы передали при её вызове
    this.radius = radius;				// Переменной radius этой функции присваиваем значение radius которое мы передали при её вызове
    this.color = color;					// Переменной color этой функции присваиваем значение color которое мы передали при её вызове
    this.isSelected = false;			// Переменная хранящая в себе информацию о том, нажали мы на круг или нет
}

function addCircle(x, y, radius, color) {			// Функция отвечающая за рисование круга и добавление его в массив, хранящий все нарисованные круги
    var circle = new Circle(x, y, radius, color);	// создаем объект circle который предсатвляет собой круг с параметрами 
    circles.push(circle);							// Сохраняем его в массиве
    drawCircles();									// Обновляем отображение всех рисунков на хосте
}

var previousDrawCircle;													// Переменная отвечающая за предыдущий круг. Т. к. их два, то она нужна, что бы потом нарисовать прямую между двумя точками

function drawCircles() {												// Функция рисуящая все элементы на холсте
    context.clearRect(0, 0, canvas.width, canvas.height);				// Очистить холст
	run();
	if (isActive) lsmDraw();											// Если линия нарисована, то она остаётся нарисованной
    for(var i=0; i<circles.length; i++) {								// Перебираем все круги
        var circle = circles[i];										// каждый новый цикл присваеваем создаем объект = объекту круга из массива
		if (previousDrawCircle != null) {								// Если предыдущий круг существует, то
			var x0 = previousDrawCircle.x; 								// сичтываем его кооординату X
			var y0 = previousDrawCircle.y;								// сичтываем его кооординату Y
			}
		previousDrawCircle = circle;									// присваиваем значение этого круга предыдущему (т. е. если это первый нарис круг, то в след цикл его координаты присвоятся переменным)
		
        context.beginPath();											// Объявляет о начале определения новой фигуры
        context.arc(circle.x, circle.y, circle.radius, 0, Math.PI*2);	// Круг с центром в координатах x, y, радиусом r, начальный угол 0, конечный переведенный в радианы 360 град = 2пи радиан.
        context.fillStyle = circle.color;								// устанавливаем цевет заливки круга
        context.strokeStyle = "red";									// Устанавливаем цвет при обводке фигуры
        if (circle.isSelected) {										// Выделяем выбранный круг рамкой, если круг выбран
            context.lineWidth = 2;										// толщина рамки 5
        }
        else {															// иначе 
            context.lineWidth = 1;										// толщина 1 (0 нельзя, так как оно не будет работать)
			context.strokeStyle = "white";								// Цвет = цвету фона, что бы небыло выделения круга
        }
        context.fill();													// Заливаем фигуру цветом
        context.stroke();												// Визуализирует путь в виде контура
		if (abc > 1) {													// если нариван первый круг, т. е. при рисовании второго рисуем линию, между двумя кругами
			context.beginPath();										// Объявляет о начале определения новой фигуры
			context.strokeStyle = "#000000";							// Цвет фигуры 
			context.lineWidth = 2;										// Толщина линии координат = 2
			context.moveTo(circle.x, circle.y); 						// Перемещает кончик пера в указанную позицию
			context.lineTo(x0, y0);										// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами x, y
			context.stroke();											// Визуализируем нарисованную линию
		}
    }
}

function clearCanvas() {// Функция очистки холста
    circles = [];		// Очистить массив кругов рисуемых мышью
	abc = 0;			// Обнулить счётчик
	circlesCanvas = []; // Очистить массив кругов рисуемых программой
	abcCanvas = 0;		// Обнуляет счётчик вызова run
	isActive = false;	// Линия не нарисована
}

// Конец блока установки точек и возможности их перетаскивать

function run()																						//Фукция рисования запуска всей программы, не считая событий связанных с мышью.
{
	var arrO = dataGeneration();																	// Присваиваем новому массиву значиния сформированного массива из значений введенных с клавиатуры
	// Блок вывода сообщений об ошибках или рекомендациях при вовде данных в поле value и дальнейше работе
	if (arrO.length < 2) return document.getElementById("info").innerHTML = 'Вы ввели меньше одной пары координат или не ввели их вовсе, повторите, пожалуйста, ввод данных.';
	else {
		if (arrO.length % 2 != 0) return document.getElementById("info").innerHTML = 'Вы ввели нечетное количество цифр, а значит пары координат не могут быт сформированы, повторите, пожалуйста, ввод данных.';
		else {
			if (document.getElementById("infoCheck").checked){
				document.getElementById("info").className = 'NoSelected';
				document.getElementById("info").innerHTML = '';
			}
			else { 
				if ((abc == 0) && (!isActive)) {
					document.getElementById("info").className = 'Selected';
					document.getElementById("info").innerHTML = 'Вы можете построить Линию Наилучшего Соответствия (далее ЛНС) по вашему усмотрению или сформировать её при помощи программы, нажав на соответствующую кнопку. Щелкните на холст, что бы поставить первую точку ЛНС.';
				}
				if (abc == 1) {
					document.getElementById("info").className = 'Selected';
					document.getElementById("info").innerHTML = 'Щелкните на холст, что бы поставить вторую точку ЛНС.';
				}
				if ((abc > 1) && (!isActive)) {
					document.getElementById("info").className = 'Selected';
					document.getElementById("info").innerHTML = 'Теперь вы можете двигать концы отрезка, выделяя их кнопкой мыши и затем перемещая по холсту, подбирая наиболее подходящее, на ваш взгляд, положение ЛНС. Также можно, щелкнув на точку построенную по введенным данным, увидеть её координату. После, можно сравнить вашу ЛНС с той, что сформирует программа методом наименьших квадратов, нажав на кнопку Построить ЛНС.';
				}
			}
		}
	}
	// Конец блока вывода сообщений об ошибках или рекомендациях при вовде данных в поле value и дальнейше работе
	var arrX = [];																					// массив значений X
	var arrY = [];																					// массив значений Y
	var arrOX = [];																					// Масив необходимые для поиска минимальных и макимальных элементов, без сортировки исходных массивов для X
	var arrOY = [];																					// Масив необходимые для поиска минимальных и макимальных элементов, без сортировки исходных массивов для Y
	if (document.getElementById("verticalAlign").checked){											// Если чекбокс с id == verticalAlign активен то 
		for (var i = 0; i < arrO.length; i++){														// Итерация по всем элементам массива
			if (i % 2 == 0) arrX.push(arrO[i]);														// Если индекс четный (то есть это х) добавляем его в конец массива с Иксами
			else arrY.push(arrO[i]);																// Иначе если он нечетный (то есть y) добавляем его в конец массива с Игреками
		}
	}
	if (document.getElementById("horizontalAlign").checked){										// Если чекбокс с id == horizontalAlign активен то 
		for (var i = 0; i < arrO.length; i++){														// Итерация по всем элементам массива
			if (i < arrO.length/2) arrX.push(arrO[i]);												// Если индекс меньше длины массива деленной пополам (то есть это х) добавляем его в конец массива с Иксами
			else arrY.push(arrO[i]);																// Иначе если он больше или равен длине массива деленной пополам (то есть y) добавляем его в конец массива с Игреками
		}
	}
	// Масивы необходимые для поиска минимальных и макимальных элементов, без сортировки исходных массивов для X и Y
	for (var i = 0; i < arrX.length; i++){															// Итерация по элементам массива
		arrOX[i] = arrX[i];																			// В новый массив записываем значения исходного
	}
	for (var i = 0; i < arrY.length; i++){															// Итерация по элементам массива
		arrOY[i] = arrY[i];																			// В новый массив записываем значения исходного
	}
	// Конец этих массивов
	
	arrOX.sort((a, b) => a - b);																	// Сортируем массив X с цифрами в порядке возрастания
	maxelX = arrOX[arrOX.length - 1];																// Переменной присваиваем значение максимального элемента в массиве X
	minelX = 0;																						// Переменной присваиваем значение минимального элемента в массиве X
	arrOY.sort((a, b) => a - b);																	// Сортируем массив Y с цифрами в порядке возрастания
	maxelY = arrOY[arrOY.length - 1];																// Переменной присваиваем значение максимального элемента в массиве Y
	minelY = 0;																						// Переменной присваиваем значение минимального элемента в массиве Y

	context.clearRect(0, 0, canvas.width, canvas.height);											// Начало поля рисования в координата 0, 0 блока cnvs а конец в координатах длины и ширины блока
	
	coordinateLines (x, y, "#000000", -10);															// Функция риcования осей координат
	scaleX = (canvas.width - canvas.width/11) / (maxelX-minelX);									// Маштаб по X равен
	positionX = minelX*(0-scaleX)+canvas.width/11;													// Позиция по X рисования равна
	scaleY = (canvas.height - canvas.height/11) / (maxelY-minelY);									// Маштаб по Y равен
	positionY = minelY*(0-scaleY)+canvas.height/11;													// Позиция по Y рисования равна
	verticalLinesX(minelX, canvas.width/11, canvas.width, canvas.width/11, (maxelX-minelX)/10);		// Рисуем черточки и подписи на оси X
	verticalLinesY(maxelY, canvas.height/11, canvas.height, canvas.height/11, (maxelY-minelY)/10);	// Рисуем черточки и подписи на оси Y
	scaleValues(arrX, arrY, scaleX, scaleY);														// Рисуем значения введенные с клавиатуры на шкале
	lsm(arrX, arrY, scaleX, scaleY);
}

function dataGeneration()							// Функция формирования данных
{
	var str = '';									// Пустая строка
	var arrS = [];									// Массив в который мы записываем значения введённые с клавиатуры
	var arrN = [];									// Массив в который мы запишем сформированные числа + '' элементы
	var arrNO = [];									// Массив в который мы запишем сформированные числа
	var arrO = [];									// Массив в который мы запишем преобразованные в числа значения введенные в поле ввода.
	arrS = document.getElementById("data").value;	// Переменная arrS берет значения из элемента data со всеми знаками - строка
	for (var i = 0; i < arrS.length; i++){			// Итерация по всем элементам строки
		if ((arrS[i] != ' ') && (arrS[i] != '\t')){	// Если элемент != пробелу и != знаку табуляции;
			if (arrS[i] == ',') str += '.';			// Если эл-т = , То вместо неё ставим .
			else str += arrS[i];					// Иначе если это не запятая то добавляем этот эл-т в конец строки
		}
		else {										// Если попалась символ пробела или табуляции
			arrN.push(str);							// Добавляем строку в конец массива
			str = '';								// Обнуляем строку
		}
	}
	arrN.push(str);									// Добавляем последний str, который не добавляется в цикле, в конец массива.
	for (var i = 0; i < arrN.length; i++){			// Итерация по всем элементам нового массива
		if (arrN[i] != '') arrNO.push(arrN[i]);		// если элемент != '' то Запишем его в конец новго массива
	}
	for (var i = 0; i < arrNO.length; i++){			// Итерация по всем элементам нового массива
		arrO[i] = parseFloat(arrNO[i], 10);			// В массив записываем преобразованные в числа значения
	}
	return arrO;									// Возвращаем массив чисел, введенных с клавиатуры
}


function coordinateLines (x, y, color, bias) 		// Функция рисования лиинй координат, где x и y начало координат со стрелочками.
{	
	context.beginPath();							// Объявляет о начале определения новой фигуры
	context.strokeStyle = color;					// Цвет линии = объявленному цвету
	context.lineWidth = 2;							// Толщина линии координат = 2
	context.moveTo(x, y); 							// Перемещает кончик пера в указанную позицию
	context.lineTo(canvas.width - x, y);			// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами ширина окна - 10, y
	context.stroke();								// Метод stroke визуализирует всё то, что мы нарисовали выше
	context.closePath();							// closePath Сооединяет точки, которые мы обозначили выше.
	context.beginPath();							// Объявляет о начале определения новой фигуры
	context.strokeStyle = color;					// Цвет линии = объявленному цвету
	context.lineWidth = 2;							// Толщина линии координат = 2
	context.moveTo(x, y); 							// Перемещает кончик пера в указанную позицию
	context.lineTo(x, canvas.height - y);			// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами x, высота окна - 10
	context.stroke();								// Метод stroke визуализирует всё то, что мы нарисовали выше
	context.closePath();							// closePath Сооединяет точки, которые мы обозначили выше.
	context.beginPath();							// Объявляет о начале определения новой фигуры
	context.strokeStyle = color;					// Цвет фигуры
	context.lineWidth = 2;							// толщина линии фигуры
	context.moveTo(canvas.width - x + bias, y - 5); // Начальная позиция пера в x, y
	context.lineTo(canvas.width - x, y);			// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами x, y
	context.lineTo(canvas.width - x + bias, y + 5);	// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами x, y
	context.stroke();								// Визуализирует путь в виде контура
	context.closePath();							// Закрывает путь, добавляя прямую линию между последней точкой и исходной точкой пути
	context.beginPath();							// Объявляет о начале определения новой фигуры
	context.strokeStyle = color;					// Цвет фигуры
	context.lineWidth = 2;							// толщина линии фигуры
	context.moveTo(x - 5, canvas.height - y - bias);// Начальная позиция пера в x, y
	context.lineTo(x, canvas.height - y);			// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами x, y
	context.lineTo(x + 5, canvas.height - y - bias);// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами x, y
	context.stroke();								// Визуализирует путь в виде контура
	context.closePath();
}

function drawPointX(position, color, labelup)				// Функция рисования одной черточки и подписи на оси Х
{
	context.beginPath();									// Объявляет о начале определения новой фигуры
	context.strokeStyle = color;							// Цвет черточек = объявленному цвету
	context.lineWidth = 2;									// ширина черточек = объявленной ширине
	context.moveTo(x + position, y - 8); 					// Начальная позиция пера в x, y
	context.lineTo(x + position, y + 8);					// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами x, y
	context.stroke();										// Визуализирует путь в виде контура
	context.closePath();									// Закрывает путь, добавляя прямую линию между последней точкой и исходной точкой пути
	context.beginPath();									// Объявляет о начале определения новой фигуры
	context.font="20px Arial";								// Определение высоты шрифта и его Начертания
	context.fillStyle = color;								// Цвет черточек = объявленному цвету
	context.lineWidth = 2;									// Ширина линии = 2
	context.fillText(labelup.toFixed(1), position, y - 15);	// Рисует залитый тест прямо на холсте (текст, x, y) Это текст сверху шкалы
	context.closePath();									// Закрывает путь, добавляя текст.
}

function verticalLinesX(signature, iZn, iIf, iUp, signatureUp)	// Функция рисования черточек и подписей на оси Х
{
		for (var i = iZn ; i <= iIf; i += iUp  ) {				//Цикл для рисования вертикальных черточек на шкале
			signature += signatureUp;							// Увеличиваем значение подписи на одну десятую.
			drawPointX(i, "#000000", signature);				// Рисуем черточки на шкале
		}
}

function drawPointY(position, color, labelup)				// Функция рисования одной черточки на оси Y
{
	context.beginPath();									// Объявляет о начале определения новой фигуры
	context.strokeStyle = color;							// Цвет черточек = объявленному цвету
	context.lineWidth = 2;									// ширина черточек = объявленной ширине
	context.moveTo(x - 8, y - position); 					// Начальная позиция пера в x, y
	context.lineTo(x + 8, y - position);					// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами x, y
	context.stroke();										// Визуализирует путь в виде контура
	context.closePath();									// Закрывает путь, добавляя прямую линию между последней точкой и исходной точкой пути
	context.beginPath();									// Объявляет о начале определения новой фигуры
	context.font="20px Arial";								// Определение высоты шрифта и его Начертания
	context.fillStyle = color;								// Цвет черточек = объявленному цвету
	context.lineWidth = 2;									// Ширина линии = 2
	context.fillText(labelup.toFixed(1), x + 15, position);	// Рисует залитый тест прямо на холсте (текст, x, y) Это текст сверху шкалы
	context.closePath();									// Закрывает путь, добавляя текст.
}

function verticalLinesY(signature, iZn, iIf, iUp, signatureUp)	// Функция рисования черточек на оси Y
{
	var signature = signature;									// переменная хранящая в себе подпись шкалы, на которой мы будем рисовать средние
		for (var i = iZn ; i < iIf; i += iUp  ) {				//Цикл для рисования вертикальных черточек на шкале
			drawPointY(i, "#000000", signature);				// Рисуем черточки на шкале
			signature -= signatureUp;							// Увеличиваем значение подписи на одну десятую.
		}
}


function circlePoint(positionX, positionY, radius, labelupX, labelupY, bias)	// Функция создания объекта круга с нобходимыми наборов свойств для дальнейших вычислений
{
	this.positionX = positionX;													// свойству positionX присвоить значение positionX
	this.positionY = positionY;													// свойству positionY присвоить значение positionY
	this.radius = radius;														// свойству radius присвоить значение radius
	this.labelupX = labelupX;													// свойству labelupX присвоить значение labelupX
	this.labelupY = labelupY;													// свойству labelupY присвоить значение labelupY
	this.bias = bias;															// свойству bias присвоить значение bias
	this.isSelectedText = false;												// свойство isSelectedText хранящее в себе информацию о том, нажали мы на круг или нет, для отображения текста
}

function drawCirclesCanvas ()																										// Функция рисования кругов с использованием массива кругов, в котором хранятся объекты круги.
{
	for(var i=circlesCanvas.length-1; i>=0; i--) {																					// перебераем все круги в массиве кругов холста
		var circle = circlesCanvas[i];																								// каждый новый цикл присваеваем создаем объект = объекту круга из массива
		context.beginPath();																										// Объявляет о начале определения новой фигуры
		context.fillStyle = "#000000";																								// Цвет фигуры 
		context.arc(x + circle.positionX, y - circle.positionY, circle.radius, 0, 2*Math.PI);										// Рисуем круг с центром в координатах x, y, радиусом r, начальный угол 0, конечный переведенный в радианы 360 град = 2пи радиан.
		context.strokeStyle = "#000000";																							// Устанавливаем цвет при обводке фигуры
		context.fill();																												// Заливаем фигуру цветом
		context.stroke();																											// Визуализирует путь в виде контура
		context.closePath();																										// Закрывает путь, добавляя контур.
		if (circle.isSelectedText) {																								// Если щелкнули по кругу
			context.beginPath();																									// Объявляет о начале определения новой фигуры
			context.font="20px Arial";																								// Определение высоты шрифта и его Начертания
			context.lineWidth = 2;																									// Ширина линии = 1
			context.fillText(circle.labelupX + ';' + circle.labelupY, circle.bias + circle.positionX, y - circle.positionY - 15);	// Рисует залитый тест прямо на холсте (текст, x, y) Это текст сверху шкалы
			context.closePath();																									// Закрывает путь, добавляя текст.
		}
	}
}

var circlesCanvas = [];																						// Массив, хранищий точки нарисованные на холсте состоящие из значений введенных с клавиатуры
var abcCanvas = 0;																							// Счётчик вызова функции run

function scaleValues(arrX, arrY, scaleX, scaleY)															// Функция рисования точек на на диаграмме рассеивания в виде круга
{
	for (var i = 0; i < arrX.length; i++) {																	// Итерация по элементам введенным с клавиатуры с помощью индексов
		var strCircleX = '';																				// Строка, в которую записываем значение Х заменяя . на ,
		var strCircleY = '';																				// Строка, в которую записываем значение Y заменяя . на ,
		var aX = String(arrX[i]);																			// переменная, хранящая в себе строковое значение переменной arrX
		var aY = String(arrY[i]);																			// переменная, хранящая в себе строковое значение переменной arrY
		for (var j = 0; j < aX.length; j++){																// Итерация по всем элементам строки
			if (aX[j] == '.') strCircleX += ',';															// Если эл-т = .  То вместо неё ставим ,
			else strCircleX += aX[j];																		// Иначе если это не запятая  то добавляем этот эл-т в конец строки
		}
		for (var j = 0; j < aY.length; j++){																// Итерация по всем элементам строки
			if (aY[j] == '.')	strCircleY += ',';															// Если эл-т = . То вместо неё ставим ,
			else strCircleY += aY[j];																		// Иначе если это не запятая то добавляем этот эл-т в конец строки
		}
		if (abcCanvas == 0) {																				// если run вызывается первый раз, то
			var circle = new circlePoint(arrX[i] * scaleX, arrY[i] * scaleY, 4, strCircleX, strCircleY, 0);	// создаем новый объект круг с заданными параметрами
			circlesCanvas.push(circle);																		// Сохраняем его в массиве при первичном вызове функции run
		}
	}
	drawCirclesCanvas();																					// вызываем функцию рисования кругов, после добавления их в массив.
	++abcCanvas;																							// увеличиваем счётчик вызова функции run
}

var a = 0;
var b = 0;
function lsm(arrX, arrY, scaleX, scaleY)									// Функция считающая коэфициенты для метода наименьших квадратов
{	
	var sum = 0;															// Сумма чисел
	var sumX = 0;															// Сумма всех координат X
	var sumY = 0;															// Сумма всех координат Y
	var sumX2 = 0;															// Сумма всех квадратов координат X
	for(var i = 0; i < arrX.length; i++){									// итерация по координатам точех (x;y)
		var kv = arrX[i]*arrY[i];											// умножение координаты х на y
		sum += kv;															// сумма этих произведений
		sumX += arrX[i];													// сумма всех координат X
		sumY +=arrY[i];														// сумма всех координат Y
		var kv2 = Math.pow(arrX[i], 2);										// Возведение в квадрат координаты X
		sumX2 += kv2;														// Сумма квадратов координаты X
	}
	a = (arrX.length*sum-sumX*sumY)/(arrX.length*sumX2-Math.pow(sumX, 2));	// коэфициент a = (количесво эл-ов * сумму произведений координат точек - произведение сумм кординат точек)/(количесвто эл-ов * сумму квадратов координаты Х - квадрат суммы координаты X) 
	b = (sumY - a * sumX) / arrX.length;									// коэфициент b = (суммв координат Y - коэфициент а * сумму координат X) / колиичество элементов
}

var isActive = false;												// Переменная отвечающая за состояние нариосвана линия или нет

function lsmDraw() 													// Функция рисования линии наилучшего соответсвия
{
	context.beginPath();											// Объявляет о начале определения новой фигуры
	context.strokeStyle = "blue";									// Цвет черточек = объявленному цвету
	context.lineWidth = 2;											// ширина черточек = объявленной ширине
	context.moveTo(x + minelX*scaleX, y - (a * minelX + b)*scaleY); // Начальная позиция пера в x, y
	context.lineTo(x + maxelX*scaleX, y - (a * maxelX + b)*scaleY);	// Создает прямой отрезок линии между текущей позицией пера и точкой с координатами x, y
	context.stroke();												// Визуализирует путь в виде контура
	context.closePath();											// Закрывает путь, добавляя прямую линию между последней точкой и исходной точкой пути
	isActive = true;												// Показываем что линия нарисована
	if (document.getElementById("infoCheck").checked){
		document.getElementById("info").className = 'NoSelected';
		document.getElementById("info").innerHTML = '';
	}
	else { 
		if (abc == 0) {
			document.getElementById("info").className = 'Selected';
			document.getElementById("info").innerHTML = 'ЛНС построена. Щелкните на холст, что бы поставить первую точку ЛНС или введите новые данные и запустить программу заново.';
		}
		if (abc > 1) {
			document.getElementById("info").className = 'Selected';
			document.getElementById("info").innerHTML = 'ЛНС построена. Вы можете, щелкнув на точку, построенную по введенным данным, увидеть её координату или ввести новые данные и запустить программу заново.';
		}
	}
}